# This file was auto-generated by Fern from our API Definition.

from .....core.pydantic_utilities import UniversalBaseModel
from ..http.http_request import HttpRequest
import pydantic
from ..method.request_method import RequestMethod
import typing
from ..method.headless_request_config import HeadlessRequestConfig
from ..method.browserbase_request_config import BrowserbaseRequestConfig
from ..method.browserbase_request_secrets import BrowserbaseRequestSecrets
from .....core.pydantic_utilities import IS_PYDANTIC_V2


class SendHttpRequestConfig(UniversalBaseModel):
    request: HttpRequest
    max_redirects: int = pydantic.Field(alias="maxRedirects")
    verify_tls: bool = pydantic.Field(alias="verifyTls")
    timeout: int
    request_method: RequestMethod = pydantic.Field(alias="requestMethod")
    headless_config: typing.Optional[HeadlessRequestConfig] = pydantic.Field(alias="headlessConfig", default=None)
    browserbase_config: typing.Optional[BrowserbaseRequestConfig] = pydantic.Field(
        alias="browserbaseConfig", default=None
    )
    browserbase_secrets: typing.Optional[BrowserbaseRequestSecrets] = pydantic.Field(
        alias="browserbaseSecrets", default=None
    )

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            extra = pydantic.Extra.allow
